# Copyright 2023- Le Filament (https://le-filament.com)
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl.html)

from datetime import datetime

from odoo import models


class TemplateModel(models.Model):
    _inherit = "financial.deal.tool"

    # ------------------------------------------------------
    # Fields declaration
    # ------------------------------------------------------

    # ------------------------------------------------------
    # SQL Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Default methods
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Computed fields / Search Fields
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Onchange / Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # CRUD methods (ORM overrides)
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Actions
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Business methods
    # ------------------------------------------------------
    def generate_contract(self):
        # FIXME A hérité de la méthode extraitre dans financial deal_contract
        contract = super().generate_contract()
        # Create associated tool

        # "duration_or_count": 15,
        # "bank_account": "FR15 984 5351 864",
        creation_dict = {
            "description": self.deal_id.description,
            "amount": self.amount,
            "payment_date": datetime.now(),
            "periodicity": "6",
            "rate": 1.60,
            "partner_id": self.deal_id.partner_id.id,
            "contract_id": contract.id,
        }

        # Create financial tool associated
        financial_tool_record = self.env[contract.deal_tool_model].create(creation_dict)
        contract.deal_tool_model_reference_id = financial_tool_record.id

        return contract
